(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define('@nonoll/code-snippet/functions', ['exports'], factory) :
    (global = global || self, factory((global.nonoll = global.nonoll || {}, global.nonoll['code-snippet'] = global.nonoll['code-snippet'] || {}, global.nonoll['code-snippet'].functions = {})));
}(this, (function (exports) { 'use strict';

    var debounce = function (fn, delay) {
        var timer;
        delay = delay || 0;
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            window.clearTimeout(timer);
            timer = window.setTimeout(function () {
                fn.apply(null, args);
            }, delay);
        };
    };

    function noop() { }

    var throttle = function (fn, delay) {
        delay = delay || 0;
        var caller = function (args) {
            fn.apply(null, args);
            base = +new Date();
        };
        var base = null;
        var isLeading = true;
        var stamp = null;
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (isLeading) {
                caller(args);
                isLeading = false;
                return;
            }
            stamp = +new Date();
            base = base || stamp;
            if ((stamp - base) >= delay) {
                caller(args);
            }
        };
    };

    exports.debounce = debounce;
    exports.noop = noop;
    exports.throttle = throttle;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=nonoll-code-snippet-functions.umd.js.map
