var debounce = function (fn, delay) {
    var timer;
    delay = delay || 0;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        window.clearTimeout(timer);
        timer = window.setTimeout(function () {
            fn.apply(null, args);
        }, delay);
    };
};

function noop() { }

var throttle = function (fn, delay) {
    delay = delay || 0;
    var caller = function (args) {
        fn.apply(null, args);
        base = +new Date();
    };
    var base = null;
    var isLeading = true;
    var stamp = null;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (isLeading) {
            caller(args);
            isLeading = false;
            return;
        }
        stamp = +new Date();
        base = base || stamp;
        if ((stamp - base) >= delay) {
            caller(args);
        }
    };
};

/*
 * Public API Surface of @nonoll/code-snippet/functions
 */

/**
 * Generated bundle index. Do not edit.
 */

export { debounce, noop, throttle };
//# sourceMappingURL=nonoll-code-snippet-functions.js.map
